package org.apache.bcel.util;

package .tmp;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Objects;
import org.apache.bcel.util.ClassPath;

class JrtModule extends ClassPath.AbstractPathEntry {
  private final Path modulePath;
  
  public JrtModule(Path modulePath) {
    this.modulePath = Objects.<Path>requireNonNull(modulePath, "modulePath");
  }
  
  public void close() throws IOException {}
  
  ClassPath.ClassFile getClassFile(String name, String suffix) {
    Path resolved = this.modulePath.resolve(ClassPath.packageToFolder(name) + suffix);
    if (Files.exists(resolved, new java.nio.file.LinkOption[0]))
      return (ClassPath.ClassFile)new Object(this, resolved); 
    return null;
  }
  
  URL getResource(String name) {
    Path resovled = this.modulePath.resolve(name);
    try {
      return Files.exists(resovled, new java.nio.file.LinkOption[0]) ? new URL("jrt:" + this.modulePath + "/" + name) : null;
    } catch (MalformedURLException e) {
      return null;
    } 
  }
  
  InputStream getResourceAsStream(String name) {
    try {
      return Files.newInputStream(this.modulePath.resolve(name), new java.nio.file.OpenOption[0]);
    } catch (IOException e) {
      return null;
    } 
  }
  
  public String toString() {
    return this.modulePath.toString();
  }
}
